@echo off & SETLOCAL ENABLEDELAYEDEXPANSION
cls & echo Local init, server lock...
mkdir hi
rename z:\Hi-Score\galaga.hi galaga.tmp
echo. & echo File locked, downloading...
copy z:\Hi-Score\galaga.tmp hi\galaga.hi

echo. & echo Merging SERVER Hi-Scores...
FOR /f "skip=1 tokens=1,2,3 delims=|" %%A IN ('HiToText -r ../hi/galaga') do (
	SET /a IsDuplicate=0
	FOR /f "skip=1 tokens=1,2,3 delims=|" %%E IN ('HiToText -r ./hi/galaga') do (
		if %%B==%%F (IF %%C==%%G SET /a IsDuplicate=1) )
	IF !IsDuplicate!==0 HiToText -w ./hi/galaga %%A %%B "%%C"
)

echo. & echo Uploading back, unlocking...
copy hi\galaga.hi z:\Hi-Score\galaga.hi
echo. & echo  - SERVER UPDATE FINISHED - & echo.

echo. & echo Merging CLIENT Hi-Scores...
FOR /f "skip=1 tokens=1,2,3 delims=|" %%A IN ('HiToText -r ./hi/galaga') do (
	SET /a IsDuplicate=0
	FOR /f "skip=1 tokens=1,2,3 delims=|" %%E IN ('HiToText -r ../hi/galaga') do ( 
		if %%B==%%F (IF %%C==%%G SET /a IsDuplicate=1) ) 
	IF !IsDuplicate!==0 HiToText -w ../hi/galaga %%A %%B "%%C"
)

echo. & echo Cleaning up temporaries...
del z:\Hi-Score\galaga.tmp
del hi\galaga.hi & rmdir hi
